//*******************************************************
//       Copyright (c) 2000-3 Gena A. Petrov
//*******************************************************
unit StrOperation;

interface

uses
  Windows, Messages;

  function Copy_(S: String;i,i1: Integer): String; overload;
  function Copy_(S: PChar;i,i1: Integer): PChar; overload;
  function PosLScan(C: Char; S: string; PosBegin, PosEnd: Integer): Integer;
  function PosRScan(Ch: char; Str: string): Integer;
  function ExtractPath(Str: string): string;
  function ExtractFileName(Str: string): string;
  function UpFirstChar(str: string): string;
  function HexToInt(sHex: string): DWord;
  function FileAttrToStr(fAttr: UINT): String;
  function GetAbsolutPath(StandPath, RelativePath: String): String;

implementation

uses
  SysUtils,
  StrList;

function Copy_(S: String;i,i1: Integer): String;
var
  P,P2: PChar;
begin
  P:= StrAlloc(i1-i+2);
  P2:= StrLCopy(P,PChar(S) + i-1,i1-i+1);
  Result:= P2;
end;

function Copy_(S: PChar;i,i1: Integer): PChar;
var
  P: PChar;
begin
  P:= StrAlloc(i1-i+2);
  Result:= StrLCopy(P,S + i,i1-i+1);
end;


function PosLScan(C: Char; S: string; PosBegin, PosEnd: Integer): Integer;
var
  i: Integer;
begin
  Result:= -1;
  for i:= PosBegin to PosEnd do
    if S[i]= C then
    begin
      Result := i;
      exit;
    end;
end;

function PosRScan(Ch: char; Str: string): Integer;
var
  i: Integer;
begin
  Result:= -1;
  for i:= length(str) downto 1 do begin
    if str[i]= ch then
    begin
      Result:= i;
      exit;
    end;
  end;
end;
//
function ExtractPath(Str: string): string;
begin
  Result:= Copy_(Str,1,PosRScan('\',str));
end;

function ExtractFileName(Str: string): string;
begin
  Result:= Copy_(Str,PosRScan('\',str)+1,length(Str));
end;

//
function UpFirstChar(Str: string): string;
var
  S: string;
begin
  Result:= Copy_(Str,1,1);
  Result:= AnsiUpperCase(Result);
  S:= Copy_(Str,1,Length(Str));
  S:= AnsiLowerCase(S);

  Result:= Result+S;
end;

function HexToInt(sHex: string): dword;
var
  i,
  a: byte;
  x,
  mnoj: DWord;
begin
  sHex:= UpperCase(sHex);
  x:= 0;

  mnoj:= 1;
  for i:= length(sHex) downto 1 do
  begin
    a:= 0;
    if (sHex[i] > #47) and (sHex[i] < #58) then
      a:= ord(sHex[i])-48
    else
      if (sHex[i] > #64) and (sHex[i] < #71) then
        a:= ord(sHex[i])-55;
    x:= x+ a*mnoj;
    mnoj:= mnoj*16;
  end;
  result:= x;
end;

function FileAttrToStr(fAttr: UINT): String;
begin
  Result:= '    ';
  if (fAttr and 1 ) <> 0 then Result[1]:='r';
  if (fAttr and 32) <> 0 then Result[2]:='a';
  if (fAttr and 2 ) <> 0 then Result[3]:='h';
  if (fAttr and 4 ) <> 0 then Result[4]:='s';
end;

function GetAbsolutPath(StandPath, RelativePath: String): String;
var
  SList,
  RList: TStrList;
  i,
  kS,
  kR: Integer;
begin
  if PosRScan('\', RelativePath) = -1 then
  begin
    Result:= StandPath + RelativePath;
  end
  else
  begin
    SList:= StrSlashToStrList(StandPath);
    RList:= StrSlashToStrList(RelativePath);

    kS:= Length(SList)-1;
    for i:= Length(RList)-1 downto 0 do
    begin
      if RList[i] = '..' then
      begin
        Dec(kS);
      end;

    end;

    kR:= Length(SList)- 1 - kS;

    Result:= '';
    for i:= 0 to kS do
    begin
      Result:= Result + SList[i]+'\';
    end;
    for i:= kR to Length(RList) - 2 do
    begin
      Result:= Result + RList[i]+'\';
    end;
    Result:= Result + RList[Length(RList) - 1];

  end;

  FreeStrList(SList);
  FreeStrList(RList);

end;


end.

